unit UnitPropEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sButtonControl, sCustomButton, StdCtrls, sMemo, sCustomListBox,
  sSkinProvider;

type
  TFormPropEdit = class(TForm)
    sSkinProvider1: TsSkinProvider;
    sListBox1: TsListBox;
    sMemo1: TsMemo;
    sBitBtn1: TsBitBtn;
    sBitBtn2: TsBitBtn;
    procedure sListBox1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sBitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sMemo1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TEditor = record
    Name : string;
    Props : string;
  end;

  TEditArray = array of TEditor;

const
  Section = 'Main';

var
  FormPropEdit: TFormPropEdit;
  a : TEditArray;
  MemoEdit : Boolean;

implementation

uses Unit1, sStoreUtils, sUtils;

{$R *.DFM}

procedure TFormPropEdit.sListBox1Click(Sender: TObject);
var
  i, c, index : integer;
begin
  MemoEdit := False;
  sMemo1.Clear;
  if (Length(a) < 1) or (sListBox1.ItemIndex < 0) then Exit;
  for index := 0 to Length(a) - 1 do begin
    if a[index].Name = sListBox1.Items[sListBox1.ItemIndex] then break;
  end;
  c := WordCount(a[index].Props, Delim);
  for i := 1 to c do begin
    sMemo1.Lines.Add(ExtractWord(i, a[index].Props, Delim));
  end;
  MemoEdit := True;
end;

procedure TFormPropEdit.FormShow(Sender: TObject);
var
  i : integer;
begin

  SetLength(a, 0);
  for i := 0 to sListBox1.Items.Count - 1 do begin
    SetLength(a, i + 1);
    a[i].Name := sListBox1.Items[i];
    a[i].Props := ReadIniString(Section, a[i].Name, PropEditors);
  end;

  sListBox1.ItemIndex := 0;
  sListBox1.SetFocus;
  sListBox1.OnClick(sListBox1);
end;

procedure TFormPropEdit.sBitBtn1Click(Sender: TObject);
var
  i : integer;
  s : string;
begin
  s := '';
  for i := 0 to Length(a) - 1 do begin
    WriteIniStr(Section, a[i].Name, a[i].Props, PropEditors);
  end;
  PropEditors.UpdateFile;
end;

procedure TFormPropEdit.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TFormPropEdit.sMemo1Change(Sender: TObject);
var
  j, i : integer;
begin
  if not MemoEdit or (csCreating in sMemo1.ControlState) or (csLoading in sMemo1.ComponentState) then Exit;
  for j := 0 to Length(a) - 1 do begin
    if a[j].Name = sListBox1.Items[sListBox1.ItemIndex] then break;
  end;
  a[j].Props := '';
  for i := 0 to sMemo1.Lines.Count - 1 do begin
    a[j].Props := a[j].Props + sMemo1.Lines[i] + ' ';
  end;
end;

end.
