unit JPMESBPrint;
{Copyright 2000-2003, J. Peter Mugaas}
interface
{$I JPM.INC}

uses ESBPCSGlobals, JPMPrint, Printers, Windows;

type
     {: This descendant of TJPMSimplePrint utilizes ESBPCS for some value printing}
     TJPMESBSimplePrint = class (TJPMSimplePrint)
     public
          {: This prints the identifier followed by the date and time value in the TFileTime structure}
          procedure PRintFileTimeVal (const Identifier: string; const Value: TFileTime);
          {: This prints the identifier followed by the value specified by the cardinal in a comma format}
          procedure PrintNumESBVal (const Identifier: string; const Value: Cardinal);
          {: This prints the identifier followed by the currency value }
          procedure PRintCurrencyVal (const Identifier: string; const Value: TESBCurrency);
     end;

implementation
uses ESBPCSConvert, ESBPCSDateTime, ESBPCSFinancials, ESBPCSGlobals2;

{ TJPMESBSimplePrint }

procedure TJPMESBSimplePrint.PRintCurrencyVal (const Identifier: string;
     const Value: TESBCurrency);
begin
     PrintStrVal (Identifier, ESBPCSFinancials.Currency2CEStr (Value));
end;

procedure TJPMESBSimplePrint.PRintFileTimeVal (const Identifier: string;
     const Value: TFileTime);
var
     DT: TDateTime;
     s: string;
begin
     if (Value.dwLowDateTime <> 0) or (Value.dwHighDateTime <> 0) then
     begin
          DT := FileTime2DateTime (Value);
          s := Time2FormatStr (DT, 't'); //we use the users short time and date format
          if Length (s) <> 0 then
               s := s + ' ' + Date2Str (DT)
          else
               s := Date2Str (DT);
          PrintStrVal (Identifier, s);
     end;
end;

procedure TJPMESBSimplePrint.PrintNumESBVal (const Identifier: string;
     const Value: Cardinal);
begin
     if Value <> 0 then
          PrintStrVal (Identifier, ESBPCSConvert.Int2CEStr (Value));
end;

end.
